;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; T E C H N I Q U E 
; 
; t mIRC utility scripts!
;
; Logview v.09
; Author: Revan (Ryan) www.technique.tk
; 
; Add-on needs mdx.dll dialog.mdx and ctl_gen.mdx 
; in the same path as logview.mrc
;
; /logview
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

alias -l logvers return v.09
alias -l mdxit {
  if ($isid) return $mircdir $+ mdx\mdx.dll
  else dll $+(",$scriptdir,mdx.dll,") $1-
}
alias -l mdxfile return $+($scriptdir,$1,.mdx)
alias logview if (!$dialog(logview)) dialog -m logview logview | else { dialog -x logview | dialog -m logview logview }
dialog -l Logview {
  title "t Logview v.09"
  size -1 -1 276 186
  option dbu
  button "@Window", 1, 3 7 270 160
  button "Ok", 2, 240 171 33 11, ok
  button "Positioner", 3, 209 171 30 11
  text "Progress bar!", 11, 4 175 150 4
  menu "&Options", 4
  item "Search", 5, 4
  menu "Directory", 12, 4
  item "New", 13, 12
  item "Reset", 14, 12
  item break, 15, 4
  item "Unload...", 16, 4
  menu "&Help", 6
  item "Help", 7, 6
  item break, 10, 6
  item "About", 8, 6
  item "Website", 9, 6
}
on *:dialog:Logview:init:*:{
  mdxit SetMircVersion $version
  mdxit MarkDialog $dname
  mdxit SetControlMDX 3 positioner size minbox maxbox > $mdxfile(dialog)
  mdxit SetControlMDX $dname 1 window > $mdxfile(dialog)
  window -hl22 @logview 
  did -a $dname 1 grab $window(@logview).hwnd @logview
  mdxit SetControlMDX $dname 11 ProgressBar smooth > $mdxfile(ctl_gen)
  did -h $dname 11
  logtitle
}
on *:dialog:logview:sclick:*:{
  if ($did == 3) {
    tokenize 32 $did(3)
    if ($1 == size) { 
      var %w = $dialog($dname).cw,%h = $dialog($dname).ch
      mdxit MoveControl $dname 1 * * $calc(%w -13) $calc(%h -54) 
      mdxit MoveControl $dname 2 $calc(%w -72) $calc(%h -30) * *
      mdxit MoveControl $dname 11 * $calc(%h -22) * *
    }
    elseif ($1 == sizing) { did -a $dname 3 setSize c $iif($9 > 400,$9,400) $iif($10 > 200,$10,200) }
  }
}
on *:dialog:logview:menu:*:{
  if ($did == 5) sclogmul $$input(Enter search text $+ $chr(44) wildcards accepted.,qe,Sclog v.01)
  elseif ($did == 7) { loghelp }
  elseif ($did == 8) { logbout }
  elseif ($did == 9) { url -an http://kickme.to/technique }
  elseif ($did == 13) { logsetdir }
  elseif ($did == 14) { unset %logview.dir | logtitle }
  elseif ($did == 16) { logunload }
}
alias -l loghelp {
  if ($isfile($scriptdir $+ readme-logview.txt)) { run $+(",$scriptdir,readme-logview.txt,") }
  else { !.echo -q $input(No readme found!,wo,No help found!) }
}
alias -l logsdir return $iif(%logview.dir,$ifmatch,$logdir)
alias -l logsetdir { set %logview.dir $$sdir(*,Pick a new log directory.) | logtitle }
alias -l logpars return $+($chr(40),$1-,$chr(41))
alias -l logdsize if ($isdir($1)) var %a = 0,%b = $findfile($1,*,0,inc %a $file($1-).size) | return $bytes(%a).suf 
alias -l loglist {
  clear -l @Logview
  var %a = $1,%b = $findfile($logsdir,*.log,0,logsort %a $1-)
  .timer 1 1 logcolor 
}
alias -l chanlog return $iif($regex($nopath($1-),^(#|\+|&)),$true,$false)
alias -l logsort {
  if ($1 == all) { aline -l @Logview $nopath($2-) }
  elseif ($1 == chan) && ($chanlog($2-)) { aline -l @Logview $nopath($2-) } 
  elseif ($1 == priv) && (!$chanlog($2-)) { aline -l @Logview $nopath($2-) }
}
alias -l logtitle if ($dialog(logview)) dialog -t Logview t Logview $logvers Logs $logpars($findfile($logsdir,*.log,0)) Size $logpars($logdsize($logsdir)) 
alias -l logclr var %a = $findfile($logsdir,*.log,*,.remove -b $+(",$1-,")) 
alias -l logrename { 
  var %a = $+($logsdir,$sline(@Logview,1))
  if ($input(Edit filename!,we,Rename first selected log.,$nopath(%a))) { 
    .rename $+(",%a,") $+(",$nofile(%a),$!,") | dline -l @Logview $sline(@Logview,1).ln | aline -l @Logview $nopath($!)
  }
}
alias -l logcolor {
  if ($window(@Logview)) {
    var %a = 1 
    while (%a <= $scon(0)) { 
      scon %a
      var %b = 1  
      while (%b <= $chan(0)) {
        if ($isfile($+(",$logsdir,$mklogfn($chan(%b)),"))) {
          if ($fline(@Logview,$mklogfn($chan(%b)),1,1)) cline -l 4 @Logview $ifmatch
        }
        inc %b
      }
      inc %a
    }
  }
}
alias -l logunload if ($$input(Do you really want to unload Logview addon?,yw,Confirm unload!)) { if ($dialog(Logview)) dialog -x Logview | unload -rs $+(",$script,") }
menu @Logview {
  dclick:{
    if ($isfile($+($logsdir,$sline(@Logview,1)))) { clear @Logview | aline @Logview LogFile: $sline(@Logview,1) Size: $bytes($file($+($logsdir,$sline(@Logview,1)))).suf | loadbuf -p @Logview $+(",$logsdir,$sline(@Logview,1),") | sline @Logview 15 }
  }
  	 List logs
  . 	 All:loglist all
  .-
  . 	 Private:loglist priv
  . 	 Channel:loglist chan
  	 Search
  .$iif($isfile($+($logsdir,$sline(@Logview,1))), 	Data $sline(@Logview,1)) :sclogtxt $+(,$logsdir,$sline(@Logview,1),) $$input(Enter search text $+ $chr(44) wildcards accepted.,qe,Sclog v.01)
  . 	Data all logs:sclogmul $$input(Enter search text $+ $chr(44) wildcards accepted.,qe,Sclog v.01)
  .-
  . 	 File names:sclog $$input(Enter search text $+ $chr(44) wildcards accepted..,qe,Sclog v.01)
  	 Selected
  .$iif($isfile($+($logsdir,$sline(@Logview,1))), 	 View) :{ clear @Logview | loadbuf -p @Logview $+(",$logsdir,$sline(@Logview,1),") }
  .$iif($isfile($+($logsdir,$sline(@Logview,1))), 	 Delete) :{ 
    if ($input(Are you sure you want to delete $sline(@Logview,0) logs?,yw,Confirm!)) {
      var %l = $sline(@Logview,0)
      while ($sline(@Logview,%l)) {
        .remove -b $+(",$logsdir,$sline(@Logview,%l),") | dline -l @Logview $sline(@Logview,%l).ln | logtitle 
        dec %l
      }
    }
  }
  .-
  ..$iif($isfile($+($logsdir,$sline(@Logview,1))), 	 Rename):logrename
  -
  	 Options
  . 	 Font:font 
  . 	 Unload:logunload
  .$iif($findfile($logsdir,*.log,1), 	 Format) : { 
    if ($$input(Are you sure you want to delete all your logs?,yw,Delete logs?)) { logclr | .timer 1 0 logview }
  }
  . 	 Refresh:logview
  .-
  .	 Close:dialog -x Logview 
}
alias -l sclog {
  if ($1) {
    var %a = $findfile($logsdir,*.log,0) | clear -l @Logview
    var %b = $findfile($logsdir,$scfix($1-),0,aline -nl @Logview $nopath($2-)) 
    dialog -t Logview Found $line(@Logview,0,1) files matching $+(',$1-,')
  }
}
alias -l sclogtxt {
  if ($2) {
    clear @Logview
    tokenize 167 $1- | var %a = $1 | tokenize 32 $2- 
    filter -bpcfw $+(",%a,") @Logview $scfix($1-)
    if ($line(@Logview,0) > 0) {
      iline -p @Logview 1 Searched log file: $nopath(%a) $line(@Logview,0) matches for $+(',$1-,')
      iline @Logview 2 - 
      dialog -t Logview Sclog Found $calc($line(@Logview,0) -2) matches for $+(',$1-,') 
    }
    else { !.echo -q $input(No matches for $+(',$1-,'),io,No matches.) }
  }
}
alias -l z if ($1 < 1) return $+($calc($1 * 1000),ms) | else return $+($1,s)
alias -l sclogmul {
  if ($1) {
    clear @Logview | clear -l @Logview
    var %d $ticks,%e,%f
    window -h @sclogmul_
    var %a = $findfile($logsdir,*.log,0) ,%c = %a 
    while (%a) {
      var %b = $+(",$findfile($logsdir,*.log,%a),")
      filter -pcbfw %b @sclogmul_ $scfix($1-)
      if ($line(@sclogmul_,0) > 0) { 
        aline 7 @Logview $nopath(%b) $line(@sclogmul_,0) matches for $+(',$1-,') 
        filter -pww @sclogmul_ @Logview *  | aline @Logview $chr(160) | aline -l 7 @Logview $nopath(%b) 
        inc %e | inc %f $line(@sclogmul_,0)
      }
      dec %a | did -va Logview 11 $int($calc(((%c - %a) * 100) / %c)))
    }
    dialog -t Logview Scanned %c files with $iif(%f,%f,0) matches for $+(',$1-,') $iif(%e,in %e files) took $z($calc(($ticks - %d) / 1000)) 
    window -c @sclogmul_ | did -hr Logview 11 
  }
}
alias scfix { 
  var %a = $1-
  if ($left($1,1) != $chr(42)) %a = $+(*,$chr(32),$1-) 
  if ($right($1-,1) != $chr(42)) %a = $+(%a,$chr(32),*)
  return %a
}
; |ur| snippet
alias -l degrade {
  var %a = $3,%b = $iif($4 isnum,$4,100)
  tokenize 44 $rgb($2) $+ , $+ $rgb($1)
  return $rgb($int($calc($4 - ($4 - $1) / %b * %a)),$int($calc($5 - ($5 - $2) / %b * %a)),$int($calc($6 - ($6 - $3) / %b * %a)))
}
alias -l logdeg var %a 0,%b = $r(0,16777215),%c = $r(0,16777215),%d = $window($1).w,%e = $window($1).h | while (%a <= %d) { drawline -r $1 $degrade(%b,%c,%a,%d) 1 %a 0 %a %e | inc %a }
alias -l logbout {
  var %a = $r(0,16777215),%b = @logviewb
  if (!$window(%b)) window -ahodpCBk0 +fd %b -1 -1 170 120 | logdeg %b 
  drawtext -or %b %a Arial -12 48 23 technique | drawrect -r %b %a 1 2 2 166 116
  drawtext -or %b %a Arial -7 38 48 Logview v.09 08/31/03 | drawtext -or %b %a Arial -7 34 72 Coder Revan (Ryan B.)
  drawtext -or %b %a Arial -7 39 60 Add-on for mIRC 6.0+ | drawtext -or %b %a Arial -7 45 84 www.technique.tk
  drawtext -or %b %a Arial -8 150 100 t
}
menu @logviewb {
  sclick:logbout
  dclick:window -c $active
}
on *:unload:unset %logview.*
on *:load:{ 
  if ($version >= 6.0) { echo $color(info) -s * Technique Logview $logvers loaded, type /logview to open. | logview | logbout }
  else { echo $color(info) -s * Your mIRC version $version will not work with this addon, update! | .unload -rs " $+ $script $+ " }
}

; Show some technique!
